import QtQuick 2.7
import QtQuick.Controls 2.0
import QtQuick.Layouts 1.0
import QtMultimedia 5.5
import Sender 1.0

ApplicationWindow {
    visible: true
    width: 640
    height: 480
    title: qsTr("Hello World")

    SwipeView {
        id: swipeView
        anchors.fill: parent
        currentIndex: tabBar.currentIndex

        Page {
            // vytvoření třídy, která se stará o odesílání
            Sender{
                id: sender
                // když je v Senderu vyvolán signál objectFound, získám resultPath a přesunu pohled na výsledek
                onObjectFound:{
                    photoPreview.source = resultPath;
                    swipeView.incrementCurrentIndex();
                    swipeView.incrementCurrentIndex();
                }
            }
            Item {
                width: 640
                height: 360
                // tlačítko pro odeslání fotografie
                // k odeslání je použit Sender, parametrem je cesta k vyfocené fotce
                Button{
                    text: "Odeslat"
                    onClicked: sender.sendImage(camera.imageCapture.capturedImagePath)
                }


            }
        }
        Page {
            Item {
                width: 640
                height: 360
                // vytvoření připojení ke kameře iphonu
                Camera {
                       id: camera
                       // co se má stát, když se vyfotí fotka
                       imageCapture {
                           onImageCaptured: {
                               photoPreview.source = preview  // Show the preview in an Image
                           }
                       }
                       // nastavení rozlišení
                       videoRecorder {
                          id: vRecorder
                          resolution: "1280x720"
                          frameRate: 30
                       }


                   }
                   // output, kde je hledáček kamery
                   VideoOutput {
                       source: camera
                       anchors.fill: parent
                       focus : visible // to receive focus and capture key events when visible
                   }
                    // mouse area, obsluhuje vyfocení fotky
                   MouseArea {
                       anchors.fill: parent
                       // po kliknutí na mouse areu se vyfotí fotka a přesune view se posune na výchozí
                       onClicked: {
                           camera.imageCapture.capture();
                           swipeView.decrementCurrentIndex();
                       }
                   }
            }
        }
        Page{
            // preview pro výsledek
            Item {
                width: 640
                height: 360

                Image {
                    id: photoPreview
                    anchors.fill : parent
                    fillMode: Image.PreserveAspectFit
                    smooth: true
                }
            }
        }
    }
    // tab bar pro jednotlivé záložky
    footer: TabBar {
        id: tabBar
        currentIndex: swipeView.currentIndex
        TabButton {
            text: qsTr("Úvod")
        }
        TabButton {
            text: qsTr("Kamera")
        }
        TabButton{
            id: foto
            text: qsTr("Výsledek")
        }
    }
}
