#include "sender.h"

Sender::Sender(QQuickItem *parent) :
    QQuickItem(parent)
{
}


 void Sender::sendImage(QString directory){
     // vytvoření manažera
     manager = new QNetworkAccessManager(this);
     // po získání odpovědi od serveru volám metodu replyImageFinished
     connect(manager, SIGNAL(finished(QNetworkReply*)), this, SLOT(replyImageFinished(QNetworkReply*)));
     // zadám endpoint pro odeslání požadavku
     QNetworkRequest request(QUrl("http://195.113.218.159:8090/image"));
     // nastavím header požadavku na plain text
     request.setHeader(QNetworkRequest::ContentTypeHeader, "text/plaintext");

     // načtu vyfocenou fotku a převedu na string
     cv::Mat test;
     test = cv::imread(directory.toStdString());
     cv::FileStorage fs(".xml", cv::FileStorage::WRITE + cv::FileStorage::MEMORY);
     fs << "myImage" << test;
     std::string matInString = fs.releaseAndGetString();

     // fotku v podobě stringu zasílám ke zpracování
     QString str = QString::fromStdString(matInString);
     manager->post(request, str.toUtf8());
 }

void Sender::replyImageFinished(QNetworkReply *reply)
{
    if (reply->error()){
        qDebug() << "ERROR!";
        qDebug() << reply->errorString();
    }else{
        // načítám json string ze serveru
        QString fullJson = reply->readAll();
        // vracím se na začátek reply, abych mohl číst atributy
        reply->seek(0);
        // čtu atributy z důvodu debugu
        qDebug() << reply->attribute(QNetworkRequest::HttpStatusCodeAttribute).toInt();
        qDebug() << reply->attribute(QNetworkRequest::HttpReasonPhraseAttribute).toString();

        // vytvořením json document a načtu data z reply
        QJsonDocument doc = QJsonDocument::fromJson(fullJson.toUtf8());
        // převedu document na objekt
        QJsonObject jo = doc.object();

        // získám string z obrázkem z jsonu
        QString imageString = jo["result"].toString();
        std::string stdImageString = imageString.toStdString();

        // převedu obrázek na Mat
        cv::FileStorage fs(stdImageString, cv::FileStorage::READ + cv::FileStorage::MEMORY);
        cv::Mat openCvImage;
        fs["myImage"] >> openCvImage;

        // získám standartní path zařízení spolu se session guidem a zvolím složku Document a dočasný název souboru.
        QString resultPath = QStandardPaths::writableLocation(QStandardPaths::HomeLocation).append("/Documents/resultImage.bmp");
        // odstraním z cesty "private"
        resultPath.replace("/private", "");
        // debug path
        qDebug() << resultPath;

        // ukládám obrázek do telefonu
        imwrite(resultPath.toStdString(), openCvImage);

        // emitnutí signálu, který odchytí QML a provede zobrazení výsledku
        emit objectFound("file://" + resultPath);


    }
    // vymazání vlákna
    reply->deleteLater();
}
