#ifndef DOWNLOADER_H
#define DOWNLOADER_H

#include <QObject>
#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QNetworkReply>
#include <QUrl>
#include <QDateTime>
#include <QFile>
#include <QDebug>
#include <QJsonParseError>
#include <QJsonDocument>
#include <QJsonValue>
#include <QJsonArray>
#include <QJsonObject>
#include <QBuffer>
#include <QQuickItem>
#include <QDir>
#include <QStandardPaths>

#include <QImage>

#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <iostream>


class Sender: public QQuickItem
{
    Q_OBJECT
public:
    explicit Sender(QQuickItem *parent = 0);
    QImage Mat2QImage(cv::Mat const& src);

public slots:
    void replyImageFinished(QNetworkReply* reply);
    void sendImage(QString directory);

private:
    QNetworkAccessManager* manager;
    std::stringstream serializeMat(cv::Mat mat);

signals:
    void objectFound(QString resultPath);



};

#endif // DOWNLOADER_H
