#include <QTime>
#include "imagecontroller.h"
#include "requestmapper.h"

ImageController::ImageController(QObject* parent)
    :HttpRequestHandler(parent) {
    // empty
}

void ImageController::service(HttpRequest &request, HttpResponse &response) {
    ImageProcessor* imgProcessor = new ImageProcessor();
    QByteArray requestBody = request.getBody();

    // načtení stringu s obrázkem
    QString imageString = QString::fromUtf8(requestBody);
    std::string stdImageString = imageString.toStdString();

    // převod obrázku na Mat
    cv::FileStorage fs(stdImageString, cv::FileStorage::READ + cv::FileStorage::MEMORY);
    cv::Mat openCvImage;
    fs["myImage"] >> openCvImage;
    // vytvoření výstupu
    BoundingBox vysledneSouradnice = imgProcessor->showDifferences(openCvImage);

    // převedení obrázku na string
    cv::FileStorage fss(".xml", cv::FileStorage::WRITE + cv::FileStorage::MEMORY);
    fss << "myImage" << vysledneSouradnice.result;
    std::string matInString = fss.releaseAndGetString();
    QString strImage = QString::fromStdString(matInString);

    // vvytvoření json objektu
    QJsonObject jobject;
    // vložení výsledku
    jobject["result"] =  strImage;
    // vložení souřadnic
    jobject["bottomLeftX"] = vysledneSouradnice.bottomLeft.x;
    jobject["bottomLeftY"] = vysledneSouradnice.bottomLeft.y;

    jobject["bottomRightX"] = vysledneSouradnice.bottomRight.x;
    jobject["bottomRightY"] = vysledneSouradnice.bottomRight.y;

    jobject["topLeftX"] = vysledneSouradnice.topLeft.x;
    jobject["topLeftY"] = vysledneSouradnice.topLeft.y;

    jobject["topRightX"] = vysledneSouradnice.topRight.x;
    jobject["topRightY"] = vysledneSouradnice.topRight.y;

    // vytvoření json dokumentu
    QJsonDocument doc(jobject);
    // převodu json dokumentu na string
    QString strJson(doc.toJson(QJsonDocument::Compact));

    // odeslání odpovědi
    response.write(strJson.toUtf8(), true);
}
