#include "imageprocessor.h"

ImageProcessor::ImageProcessor(){

}

/* Metoda pro převod Mat na stupně šedi
void ImageProcessor::toGrayscale(QImage image){
    if (m_grayscale){
        qDebug() << "Prevadim na grayscale";
        cv::Mat oldImg = QImage2MatAllChannels(image);
        cv::Mat gsImg;
        cv::cvtColor(oldImg, gsImg, cv::COLOR_BGR2GRAY);

        QImage bw = Mat2QImageAllChannels(gsImg);

        QString filename = m_path + "/" + m_fileName + "_gs.jpg";
        bw.save(filename);
    }
}*/
/* metoda pro odečtení barevného kanálu
// cv::Mat je ve formátu BGR proto je modrý kanál na pozici 0 atd.
void ImageProcessor::substractChannel(QImage image, Color colorChannel){
    QString filename;
    cv::Mat img = QImage2MatAllChannels(image);
    std::vector<cv::Mat> channels;
    cv::split(img, channels);

    // dle typu kanálu získaného z configu se odečte ten požadovaný
    switch(colorChannel){
    case Color::Red:
        channels[2] = cv::Mat::zeros(img.rows, img.cols, CV_8UC1);
        filename = m_path + "/" + m_fileName + "_minusRed.jpg";
        break;
    case Color::Green:
        channels[1] = cv::Mat::zeros(img.rows, img.cols, CV_8UC1);
        filename = m_path + "/" + m_fileName + "_minusGreen.jpg";
        break;
    case Color::Blue:
        channels[0] = cv::Mat::zeros(img.rows, img.cols, CV_8UC1);
        filename = m_path + "/" + m_fileName + "_minusBlue.jpg";
        break;
    default:
        qDebug() << "Barva nebyla odectena";
        break;
    }

    // spojení upravených kanálů s originálním obrázkem
    cv::merge(channels, img);
    QImage newImg = Mat2QImageAllChannels(img);
    newImg.save(filename);
}*/
// čtení config souboru
/*void ImageProcessor::readConfigFile(){
    if (!m_config.isEmpty()){
        QJsonObject jo = m_config.object();
        // metoda .value získá hodnotu pro určitý objekt v .json souboru
        QJsonValue fileName = jo.value(QString("fileName"));
        QJsonValue grayscale = jo.value(QString("grayscale"));
        QJsonValue substraction = jo.value(QString("substractColorChannel"));
        QString sub = substraction.toString();
        sub = sub.toLower();

        m_fileName = fileName.toString();
        m_grayscale = grayscale.toBool();

        if (sub == "red"){
            m_substraction = Color::Red;
        }
        if (sub == "green"){
            m_substraction = Color::Green;
        }
        if (sub == "blue"){
            m_substraction = Color::Blue;
        }
        if (sub == "none"){
            m_substraction = Color::None;
        }
    }else{
        qDebug() << "nebyl otevren config";
    }

}*/
// =========================
// obyčejné getry a setry
void ImageProcessor::setPath(QString path){
    m_path = path;
}

QString ImageProcessor::getFileName(){
    return m_fileName;
}
/*bool ImageProcessor::getConvertToGreyscale(){
    return m_grayscale;
}*/
/*Color ImageProcessor::getSubstraction(){
    return m_substraction;
}*/
/*void ImageProcessor::setConfigFile(QJsonDocument config){
    m_config = config;
}*/

// =========================
// zobrazeni bounding boxu shody obrazku
BoundingBox ImageProcessor::showDifferences(cv::Mat image){
    BoundingBox souradnice;
    // Vybiram bruteforce (true) nebo FLANN (false)
    bool brute = false;
    // Metody detekce keypointu
    std::string methodDetect = "SURF";
    // Extrakce keypoint
    std::string methodExtract = "SURF";

    // Instance tridy, ktera dela prepocitavani
    FeatureProcessing processor = FeatureProcessing();

    // Nacteni obrazku sceny a hledaneho objektu
    //cv::Mat img_scene = image;
    //cv::Mat img_scene = QImage2MatAllChannels(image);
    cv::Mat img_scene = cv::imread("/Users/tomasisa/Desktop/bigben_2.jpeg");
    cv::Mat img_object = cv::imread("/Users/tomasisa/Desktop/bigben_crop.jpeg");

    /// Vytvor detektor
    cv::Ptr<cv::FeatureDetector> featureDetector = cv::FeatureDetector::create(methodDetect);
    std::vector<cv::KeyPoint> kp_obj;
    std::vector<cv::KeyPoint> kp_scn;

    // Vydetekuj keypointy pro scenu a pro hledany objekt
    featureDetector->detect(img_scene, kp_scn);
    featureDetector->detect(img_object, kp_obj);

    // Vytvor extraktor
    cv::Ptr<cv::DescriptorExtractor> featureExtractor = cv::DescriptorExtractor::create(methodExtract);

    cv::Mat desc_scn;
    cv::Mat desc_obj;

    // Udelej extrakci keypointu
    featureExtractor->compute(img_scene, kp_scn, desc_scn);
    featureExtractor->compute(img_object, kp_obj, desc_obj);


    std::vector< cv::DMatch > matches;

    if ( desc_scn.empty() )
       cvError(0,"MatchFinder","1st descriptor empty",__FILE__,__LINE__);
    if ( desc_obj.empty() )
       cvError(0,"MatchFinder","2nd descriptor empty",__FILE__,__LINE__);

    /// Najdi shody
    if (brute) {
        //cv::BFMatcher matcher(NORM_L2);
        cv::BFMatcher matcher(cv::NORM_HAMMING);
        matcher.match( desc_obj, desc_scn, matches );

    } else {
        cv::FlannBasedMatcher matcher;
        if(desc_scn.type()!=CV_32F) { desc_scn.convertTo(desc_scn, CV_32F); }
        if(desc_obj.type()!=CV_32F) { desc_obj.convertTo(desc_obj, CV_32F); }
        matcher.match( desc_obj, desc_scn, matches );
    }

    // pro FAST min_dist=90
    double max_dist = 0; double min_dist = 100;

    // Vyhledani "podobnosti bodu"
    for( int i = 0; i < desc_obj.rows; i++ )
    { double dist = matches[i].distance;
        if( dist < min_dist ) min_dist = dist;
        if( dist > max_dist ) max_dist = dist;
    }

    // Vebereme pouze nejpodobnejsi body
    std::vector< cv::DMatch > good_matches;

    for( int i = 0; i < desc_obj.rows; i++ ){
        if( matches[i].distance < 3*min_dist ){
            good_matches.push_back( matches[i]);
        }
    }

    // Zapis shody do Matu
    cv::Mat img_matches;
    cv::drawMatches( img_object, kp_obj, img_scene, kp_scn,
                     good_matches, img_matches, cv::Scalar::all(-1), cv::Scalar::all(-1),
                     std::vector<char>(), cv::DrawMatchesFlags::NOT_DRAW_SINGLE_POINTS );

    // Vezmi vsechny "nejpodobnejsi shody",
    std::vector<cv::Point2f> obj;
    std::vector<cv::Point2f> scene;
    for( int i = 0; i < good_matches.size(); i++ )
    {
        // uloz je do vektory
        obj.push_back( kp_obj[ good_matches[i].queryIdx ].pt );
        scene.push_back( kp_scn[ good_matches[i].trainIdx ].pt );
    }

    cv::Mat H;

    if (obj.size()>3) {


        /// Z techto bodu pak najdi matici homografie
        H = cv::findHomography( obj, scene, CV_RANSAC );


        // Vytvor ctverec, ktery ma velikost hledaneho objektu
        std::vector<cv::Point2f> obj_corners(4);
        obj_corners[0] = cvPoint(0,0);
        obj_corners[1] = cvPoint( img_object.cols, 0 );
        obj_corners[2] = cvPoint( img_object.cols, img_object.rows );
        obj_corners[3] = cvPoint( 0, img_object.rows );
        std::vector<cv::Point2f> scene_corners(4);

        // Perspektivne zkresli ctverec podle nalezene matice homografie
        perspectiveTransform( obj_corners, scene_corners, H);

        souradnice.bottomLeft.x = scene_corners[0].x;
        souradnice.bottomLeft.y = scene_corners[0].y;

        souradnice.bottomRight.x = scene_corners[1].x;
        souradnice.bottomRight.y = scene_corners[1].y;

        souradnice.topRight.x = scene_corners[2].x;
        souradnice.topRight.y = scene_corners[2].y;

        souradnice.topLeft.x = scene_corners[3].x;
        souradnice.topLeft.y = scene_corners[3].y;

        //Zapis perspektivne zkresleny ctverec
        cv::line( img_matches, scene_corners[0] + cv::Point2f( img_object.cols, 0), scene_corners[1] + cv::Point2f( img_object.cols, 0), cv::Scalar(0, 255, 0), 4 );
        cv::line( img_matches, scene_corners[1] + cv::Point2f( img_object.cols, 0), scene_corners[2] + cv::Point2f( img_object.cols, 0), cv::Scalar( 0, 255, 0), 4 );
        cv::line( img_matches, scene_corners[2] + cv::Point2f( img_object.cols, 0), scene_corners[3] + cv::Point2f( img_object.cols, 0), cv::Scalar( 0, 255, 0), 4 );
        cv::line( img_matches, scene_corners[3] + cv::Point2f( img_object.cols, 0), scene_corners[0] + cv::Point2f( img_object.cols, 0), cv::Scalar( 0, 255, 0), 4 );

        cv::line( img_scene, scene_corners[0], scene_corners[1], cv::Scalar(0, 255, 0), 4 );
        cv::line( img_scene, scene_corners[1], scene_corners[2], cv::Scalar( 0, 255, 0), 4 );
        cv::line( img_scene, scene_corners[2], scene_corners[3], cv::Scalar( 0, 255, 0), 4 );
        cv::line( img_scene, scene_corners[3], scene_corners[0], cv::Scalar( 0, 255, 0), 4 );

    }



    // Vykresli obrazek se shodami a perspektivne zkreslenym ctvercem
    //cv::imshow( "Nalezene shody a perspektivne zkresleny ctverec", img_matches );
    imwrite( "/Users/tomasisa/Desktop/testovaci.jpg", img_matches);
    //cv::waitKey(0);
    souradnice.result = img_scene;

    return souradnice;

}
