#ifndef IMAGEPROCESSOR_H
#define IMAGEPROCESSOR_H
#include <QImage>
#include <opencv2/opencv.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/imgproc/types_c.h>
#include <QDebug>
#include <QFile>
#include <QJsonDocument>
#include <QJsonObject>
#include <QDir>
#include "featureprocessing.h"
#include "boundingbox.h"

/// výčtová třída představující barevné kanály
enum Color {
    Red, Green, Blue, None
};
class ImageProcessor{
private:
    /// název souboru získaný z configu
    QString m_fileName;
    /// chci/nechci převod na stupně šedi
    //bool m_grayscale;
    /// proměnná která obsahuje jméno kanálu pro odečtení
    //Color m_substraction;
    /// proměnná pro uložení cílové složky
    QString m_path;
    //QJsonDocument m_config;
public:
    /// konstruktor ImageProcessoru který volá čtení configu
    ImageProcessor();
    /// převod na stupně šedi
    //void toGrayscale(QImage image);
    /// odečtení barevného kanálu
    //void substractChannel(QImage image, Color colorChannel);
    /// přečtení configu
    //void readConfigFile();
    /// nastavení cílového adresáře
    void setPath(QString path);
    QString getFileName();
    //bool getConvertToGreyscale();
    //Color getSubstraction();
    //void setConfigFile(QJsonDocument config);

    BoundingBox showDifferences(cv::Mat image);
};

#endif // IMAGEPROCESSOR_H
